      SUBROUTINE F02GJF(N,AR,IAR,AI,IAI,BR,IBR,BI,IBI,EPS1,ALFR,ALFI,
     *                  BETA,MATZ,ZR,IZR,ZI,IZI,ITER,IFAIL)
C     MARK 8 RELEASE. NAG COPYRIGHT 1979.
C     MARK 11.5(F77) REVISED. (SEPT 1985.)
C
C     THIS ROUTINE IS THE COMPLEX ANALOGUE OF THE QZ ALGORITHM FOR
C     SOLVING THE GENERALIZED MATRIX EIGENVALUE PROBLEM,
C     A*Z = LAMBDA*B*Z
C     WHERE A AND B ARE REAL SQUARE MATRICES.
C     REFERENCE
C     SIAM J. NUMER. ANAL., 10, PP241-256, 1973.
C     C.B. MOLER AND G.W. STEWART.
C
C     THIS BLACK BOX ROUTINE WAS WRITTEN BY
C     W. PHILLIPS OXFORD UNIVERSITY COMPUTING SERVICE
C
C     IT CALLS F02GJX, F02GJY AND F02GJZ WHICH
C     WERE OBTAINED FROM EISPACK.
C
C     .. Parameters ..
      CHARACTER*6       SRNAME
      PARAMETER         (SRNAME='F02GJF')
C     .. Scalar Arguments ..
      DOUBLE PRECISION  EPS1
      INTEGER           IAI, IAR, IBI, IBR, IFAIL, IZI, IZR, N
      LOGICAL           MATZ
C     .. Array Arguments ..
      DOUBLE PRECISION  AI(IAI,N), ALFI(N), ALFR(N), AR(IAR,N), BETA(N),
     *                  BI(IBI,N), BR(IBR,N), ZI(IZI,N), ZR(IZR,N)
      INTEGER           ITER(N)
C     .. Local Scalars ..
      INTEGER           ISAVE
C     .. Local Arrays ..
      CHARACTER*1       P01REC(1)
C     .. External Functions ..
      INTEGER           P01ABF
      EXTERNAL          P01ABF
C     .. External Subroutines ..
      EXTERNAL          F02GJX, F02GJY, F02GJZ
C     .. Executable Statements ..
      ISAVE = IFAIL
      IFAIL = 1
      CALL F02GJX(N,AR,IAR,AI,IAI,BR,IBR,BI,IBI,MATZ,ZR,IZR,ZI,IZI)
      CALL F02GJY(N,AR,IAR,AI,IAI,BR,IBR,BI,IBI,EPS1,ALFR,ALFI,BETA,
     *            MATZ,ZR,IZR,ZI,IZI,ITER,IFAIL)
      IF (IFAIL.EQ.0) GO TO 20
      IFAIL = P01ABF(ISAVE,IFAIL,SRNAME,0,P01REC)
      RETURN
   20 IF (MATZ) CALL F02GJZ(N,AR,IAR,AI,IAI,BR,IBR,BI,IBI,ALFR,ALFI,
     *                      BETA,ZR,IZR,ZI,IZI)
      RETURN
      END
