      program orr_sommerfield_diph

      implicit none
      include 'orr.h'
      include 'local.h'

      INTEGER          NMAX, IAR, IAI, IBR, IBI, IVR, IVI
      PARAMETER        (NMAX=300,IAR=NMAX,IAI=NMAX,IBR=NMAX,IBI=NMAX,
     .                 IVR=NMAX,IVI=NMAX)
      INTEGER          NIN, NOUT , nnout
      PARAMETER        (NIN=5,NOUT=6)

      real*8   AI(IAI,NMAX), ALFI(NMAX), ALFR(NMAX),
     .     AR(IAR,NMAX), BETA(NMAX), BI(IBI,NMAX),
     .     BR(IBR,NMAX), VI(IVI,NMAX), VR(IVR,NMAX),
     .     z,aux,aux_i,zero,Umax,one,norm,norml,
     .     speed(NMAX),grdec(NMAX),growt(NMAX)

      INTEGER  ITER(NMAX),ibyspeed(NMAX),ibygrdec(NMAX),
     .     ibygrowt(NMAX)
      DOUBLE PRECISION EPS1,alphamin,speedcutoff
      INTEGER  I, IFAIL, J, N, NU, M, k, l, NEig,M1,M2,ii
     .   ,icro,icio,igro,howmanyacr,howmanyaci,howmanygro
     .   ,ak,howmanyalphas
      LOGICAL          MATV

*     .. External Functions ..
      DOUBLE PRECISION X02AJF,tche2,tche4,tche,pi
      real*8 liquid,liquid1,liquid2,gaz,gaz1,gaz2,y,cte,ctel
      real*8 boundary

cc
cc  weloop = W(hat)E(ver) LOOP = code must be changed slightly
cc   to run different parameter loops
cc   (attn: changing visc ratio requires changing ctel in local.h)
cc  change: loop range, assigned variable, write statement
cc  saveit = to keep read-in version of whatever
cc
      real*8 saveit,weloop,saveRe

      EXTERNAL         X02AJF
*     .. External Subroutines ..
      EXTERNAL         F02GJF


      
          call read_par()
          zero=0.0d0
          one=1.0d0
c              write(*,*) M1,M2,N1,N2
          N=N1+N2+2
          M1=N1-3
          M2=N2-3
c          write(*,*) M1,M2,N1,N2,N
c          stop

          norm = -2./hmax
          norml=  2./hmin

         do i=1,NMAX
            do k=1,NMAX
              AR(i,k)=0.0
              AI(i,k)=0.0
              BR(i,k)=0.0
              BI(i,k)=0.0
           enddo
         enddo
     
c         write(*,*) S,F,M1,M2

         call write_profil(M1,M2,hmax,hmin)
         call write_par()

c         open(20,file="toutval")
c         open(21,file="acrsval")
c          open(unit=31,file='acrsfun')
c         open(22,file="acisval")
c          open(unit=32,file='acisfun')

         open(23,file="cisval")
          open(unit=33,file='cisfun')



c to check fullana, etc         do alpha=.9,1.9,1.
c a quick test                  do alpha=0.3125,2*0.3125,0.3125
c     or                        do alpha=0.03125,4.25,0.03125

        if (uniqalpha.le.1) then
          howmanyalphas = 1
          alphamin = alpha
          alphainterval = 1.0
        else
          howmanyalphas = uniqalpha
          alphamin = alpha
        endif


        saveit = visc_rat
        saveRe = Re

        do weloop=-3.0,-0.1,0.1
           visc_rat = 10.**weloop
           cte = h/visc_rat
           print *,"doing weloop,visc_rat=",weloop,visc_rat


cccccc the alpha loop is based on getting higher resolution
cccccc around small alpha
cccccc the commented lines offer an evenly spaced alternative

        do ak = 0,howmanyalphas-1

             alpha = alphamin + 
     .        alphainterval*(dfloat(ak)/dfloat(howmanyalphas-1))
c 
c here a (1-cos) spacing option for wavenumber
c replace similar line above if desired
c     .        alphainterval*(1.d0-cos(0.5d0*pi*ak/howmanyalphas))
         

c gamma is the infinity solution, used in orr_dip, not here in _wip
c
c           gamma = complex(alpha**2,
c     .      (alpha*Re*dens_rat/visc_rat)*gaz(hmax))**0.5


           do i=1,NMAX
             do k=1,NMAX
               AR(i,k)=0.0
               AI(i,k)=0.0
               BR(i,k)=0.0
               BI(i,k)=0.0
             enddo
           enddo

           do k=1,M1-1
             z = cos(pi*k/M1)
             y = (z-1.)*hmin/2.
             do i = 0,N1-1
               AR(k,i+1) = norml**4*tche4(i,z)
     .                    - 2.*norml**2*tche2(i,z)*alpha**2
     .                    + tche(i,z)*alpha**4
           
               AI(k,i+1) = alpha*Re*liquid2(y)*tche(i,z)
     .                - alpha*Re*liquid(y)*(norml**2*tche2(i,z)
     .                - tche(i,z)*alpha**2)

               BR(k,i+1) = 0.0

               BI(k,i+1) = -1.*alpha*Re*(norml**2*tche2(i,z)
     .                    - tche(i,z)*alpha**2)
            enddo
         enddo

c____________________________________________________________________
c  boundary condition at y = -hmin (z = -1)
         do i = 0,N1-1
c  phi_l = 0
c  (-1.)**i a_l(i) = 0
            AR(M1,i+1) = boundary(0,i,-one)

c  phi_l' = 0
c  (-1.)**(i+1)*i**2 a_l(i) = 0   
            AR(M1+1,i+1) = norml*boundary(1,i,-one)
         enddo

         
c  boundary (match) condition at y=0 (z=1)
c  U_l' phi_l - U_g' phi_g = c(phi_g' - phi_l')
         do i = 0,N1-1
            AR(M1+2,i+1) = liquid1(zero)   
            BR(M1+2,i+1) = -1.*norml*boundary(1,i,one)
c  i**2
         enddo
         do i = 0,N2-1
            AR(M1+2,N1+i+1) = -1.*gaz1(zero)  
            BR(M1+2,N1+i+1) = norm*boundary(1,i,one)
c  i**2
         enddo
        
c  boundary (match) condition at y=0 (z=1)
c  phi_l - phi_g = 0
         do i = 0,N1-1
            AR(M1+3,i+1) = 1.
         enddo
         do i = 0,N2-1
            AR(M1+3,N1+i+1) = -1.
         enddo
c____________________________________________________________________
          


c====================================================================




         do k=1,M2-1
          z=cos(pi*k/M2)
          y=(1.-z)*(hmax/2.)
          do i=0,N2-1
            AR(M1+3+k,N1+i+1) = norm**4*tche4(i,z)
     .        - 2.*norm**2*tche2(i,z)*alpha**2
     .        + tche(i,z)*alpha**4
           
            AI(M1+3+k,N1+i+1) = 
     .       alpha*Re*(dens_rat/visc_rat)*gaz2(y)*tche(i,z)
     .    -  alpha*Re*(dens_rat/visc_rat)*gaz(y)*(norm**2*tche2(i,z)
     .    -  tche(i,z)*alpha**2)

            BR(M1+3+k,N1+i+1) =0.0

            BI(M1+3+k,N1+i+1)= -1.*alpha*Re*(dens_rat/visc_rat)*
     .       (norm**2*tche2(i,z)-tche(i,z)*alpha**2)
          enddo
         enddo




ccc   boundary condition at y=0  (z=1)
         do i=0,N1-1

            AR(M1+3+M2,i+1)=alpha**2 + boundary(2,i,one)*norml**2
c (i**2*(i**2-1)/3)

c$$$            AR(M1+3+M2,i+1) = liquid2(zero)
c$$$            BR(M1+3+M2,i+1) = -1.*alpha**2 - (i**2*(i**2-1)/3)

         enddo

         do i=0,N2-1

           AR(M1+3+M2,N1+i+1)=-1.*visc_rat*
     .      (norm**2*boundary(2,i,one)+alpha**2)
c(i**2*(i**2-1)/3)

c$$$            AR(M1+3+M2,N1+i+1)= -1.*visc_rat*gaz2(zero)
c$$$            BR(M1+3+M2,N1+i+1)= visc_rat*((i**2*(i**2-1)/3) +alpha**2)
         enddo

        



ccc   boundary condition at y=0  (z=1)

         do i=0,N1-1

           AR(M1+4+M2,i+1)= norml**3*boundary(3,i,one)-
     .      3*alpha**2*norml*boundary(1,i,one)

           AI(M1+4+M2,i+1)= alpha*Re*liquid1(zero)
     .      + ((alpha*Re*(F+alpha**2*S)*norml*boundary(1,i,one))
     .      / (liquid1(zero)-gaz1(zero)))

           BI(M1+4+M2,i+1) = -alpha*Re*norml*boundary(1,i,one)

         enddo

         do i=0,N2-1

           AR(M1+4+M2,N1+i+1)= -visc_rat*(norm**3*boundary(3,i,one)
     .      - 3*alpha**2*norm*boundary(1,i,one))

           AI(M1+4+M2,N1+i+1)= -dens_rat*Re*alpha*gaz1(zero)
     .      - ((alpha*Re*(F+alpha**2*S)*norm*boundary(1,i,one))
     .      / (liquid1(zero)-gaz1(zero)))
           
           BI(M1+4+M2,N1+i+1)= dens_rat*Re*alpha*norm*boundary(1,i,one)

         enddo





ccc   boundary condition at y=hmax  (z=-1)

c for uniform upper solution in y>hmax region  
c        do i=0,N2-1
c            AR(M1+5+M2,N1+i+1)=  boundary(0,i,-one)
c        enddo
c        AR(M1+5+M2,N1+N2+1)=  -1.
c        AR(M1+5+M2,N1+N2+2)=  -1.




c for impen upper boundary at y=hmax (z=-1)
        do i=0,N2-1
            AR(M1+5+M2,N1+i+1)= boundary(0,i,-one)
        enddo



ccc   boundary condition at y=hmax (z=-1)
c for uniform upper solution in y>hmax region
c        do i=0,N2-1
c            AR(M1+6+M2,N1+i+1)= -1.*gaz(hmax)*norm*boundary(1,i,-one)
c            BR(M1+6+M2,N1+i+1)=-1.*norm*boundary(1,i,-one)
c        enddo
c        AR(M1+6+M2,N1+N2+1)=  -alpha*gaz(hmax)
c        AR(M1+6+M2,N1+N2+2)=  -real(gamma)*gaz(hmax)
c        AI(M1+6+M2,N1+N2+2)=  -imag(gamma)*gaz(hmax)  
c        BR(M1+6+M2,N1+N2+2)=  -real(gamma) 
c        BI(M1+6+M2,N1+N2+2)=  -imag(gamma)




c for impen upper boundary at y=hmax (z=-1)
        do i=0,N2-1
            AR(M1+6+M2,N1+i+1)= norm*boundary(1,i,-one)
        enddo





ccc   boundary condition at y=hmax    (z=-1)
c for uniform upper solution in y>hmax region
c        do i=0,N2-1
c          AR(M1+7+M2,N1+i+1)= norm**2*boundary(2,i,-one)
c     .     - (gaz2(hmax)/gaz1(hmax))*norm*boundary(1,i,-one)
c        enddo
c
c        AR(M1+7+M2,N1+N2+1)= -1.*((gaz2(hmax)/gaz1(hmax))*alpha
c     .     + 2*alpha**2)
c           
c        AR(M1+7+M2,N1+N2+2)=-1.*((gaz2(hmax)/gaz1(hmax))
c     .     *real(gamma)+dreal(alpha**2+gamma**2))
c 
c        AI(M1+7+M2,N1+N2+2) = -1.*((gaz2(hmax)/gaz1(hmax))
c     .     *imag(gamma) + dimag(alpha**2+gamma**2))
c
c for impen upper bc there is no additional equation

ccc   boundary condition at y=hmax (z=-1)
c for uniform upper solution in y>hmax region
c        do i=0,N2-1
c          AR(M1+8+M2,N1+i+1)= norm**3*boundary(3,i,-one) -
c     .      alpha*norm*boundary(1,i,-one)
c        enddo
c
ccccc ?           AR(M1+8+M2,N1+N2+1)=  3*alpha**3
c
c        AR(M1+8+M2,N1+N2+2)= dreal(gamma**3-alpha**2*gamma)     
c        AI(M1+8+M2,N1+N2+2)= dimag(gamma**3-alpha**2*gamma)
c for impen upper bc there is no additional equation


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


        EPS1 = X02AJF()
        MATV = .TRUE.
        IFAIL = 1

        NU = N-2
        CALL F02GJF(NU,AR,IAR,AI,IAI,BR,IBR,BI,IBI,EPS1,ALFR,ALFI,
     .      BETA,MATV,VR,IVR,VI,IVI,ITER,IFAIL)

         if(ifail.ne.0) write (*,*) "error in f02gjf, ifail = ",ifail

           nnout = 10
           DO 20 I = 1, NU
             if (beta(i).ne.0.0) then
               ALFR(I) = ALFR(I)/BETA(I)
               ALFI(I) = ALFI(I)/BETA(I)
             else
               alfr(i) = 0.0d0
               alfi(i) = 0.0d0
             endif
             speed(i)= dabs(alfr(i))
             ibyspeed(i)=i
             grdec(i)= dabs(alfi(i))
             ibygrdec(i)=i
             growt(i)= -alfi(i)
             ibygrowt(i)=i
   20      CONTINUE

        call sort(nu,ibyspeed,speed)
        call sort(nu,ibygrdec,grdec)
        call sort(nu,ibygrowt,growt)

        speedcutoff = gaz(hmax)

         icro = 0
         icio = 0
         igro = 0
         howmanyacr = 16
         howmanyaci = 8
         howmanygro = howmanyefuns

         do i = 1, nu
           j = ibyspeed(i)
           k = ibygrdec(i)
           l = ibygrowt(i)
c           write (20,121) i,i,alfr(i),alfi(i),alpha

c  Write only the first 'howmany' non-zero sorted eigenvalues
c  and eigenvectors

c  sort by |c_r| = ACR set here:
           if((alfr(j).ne.0.).or.(alfr(j).ne.0.)) then
             if(icro.lt.howmanyacr) then

              if(dabs(alfr(j)).lt.speedcutoff) then
               if(dabs(alpha*alfi(j)).lt.alcicutoff) then
                icro = icro + 1
cc                write (21,121) i,j,alfr(j),alfi(j),alpha
cc                call write_eigenfun(j,M1,M2,N,hmax,hmin
cc     .           ,VR,ivr,VI,ivi,31,iwritefuns)
               endif
              endif

             endif
           endif

c  sort by |c_i| = ACI set here:
           if((alfr(k).ne.0.).or.(alfr(k).ne.0.)) then
             if(icio.lt.howmanyaci) then

              if(dabs(alfr(k)).lt.speedcutoff) then
               if(dabs(alpha*alfi(k)).lt.alcicutoff) then
                icio = icio + 1
cc                write (22,121) i,k,alfr(k),alfi(k),alpha
cc                call write_eigenfun(k,M1,M2,N,hmax,hmin
cc     .           ,VR,ivr,VI,ivi,32,iwritefuns)
               endif
              endif

             endif
           endif

c  sort by c_i = CI set here, including surfer vector/value
           if((alfr(l).ne.0.).or.(alfr(l).ne.0.)) then
             if(igro.lt.howmanygro) then

              if(dabs(alfr(l)).lt.speedcutoff) then
               if(dabs(alpha*alfi(l)).lt.alcicutoff) then
                igro = igro + 1
c OLD format:    write (23,121) i,l,alfr(l),alfi(l),alpha,Re
                write (23,*) 10.**weloop,alpha,alpha*alfi(l),alfr(l)
                call flush(23)
                call write_eigenfun(l,M1,M2,N,hmax,hmin
     .           ,VR,ivr,VI,ivi,33,iwritefuns)

                if(igro.eq.1) then
                write (*,122) alfr(l),alfi(l),alpha

                endif

               endif
              endif

             endif
           endif
        enddo

  121   format(2i5,1p,2e18.9,2e14.5)
  122   format(" unstablest c_r,c_i,k: ",1p,e14.5,2e18.9)

        enddo ! ak (alpha) loop
        enddo ! weloop (whatever) loop

       stop

      END



